

var mstSliderRangeSingleHandleDefaults = {
	animate: true,
	min: 0,
	max: 100,
	orientation: "horizontal",
	step: 1,
	value: 10
};


/**
*	Extend out jQuery-UI Slider to have custom functionality that is required.
*	E.g. Bind slider to range value and input, etc.
*/
var customSlider = function(dataVal, options) {
	// console.log('running!');

	if(typeof jQuery(dataVal) == "undefined" || jQuery(dataVal).length == 0) {

		var sliderDataValue = jQuery("[data-mst-slider=" + dataVal + "]");

	} else {
		var sliderDataValue = jQuery(dataVal);
	}

	sliderDataValue.slider(jQuery.extend({}, mstSliderRangeSingleHandleDefaults, options)), sliderDataValue.slider({
		create: function( event, ui ) {

			// console.log('Triggered!');
		},
		change: function(event, ui) {
			
			/**
			*	Retrieve the symbol if one exists
			*/
			var rip = sliderDataValue.parent('.__mst_slider_ctn').find(".__mst_slider_input");

			var symbol = sliderDataValue.parent('.__mst_slider_ctn').find('.__mst_slider_symbol');

			if(symbol.length > 0) {


				// console.log(rip.children());
				if(rip.children().first().hasClass('__mst_slider_symbol')) {
					//Before
					var value = symbol.html() + ui.value;
				} else {
					//After
					var value = ui.value + symbol.html();
				}

			} else {
				var value = ui.value;
			}



			sliderDataValue.parent('.__mst_slider_ctn').find(".__mst_slider_range_input").val(value);
			sliderDataValue.parent('.__mst_slider_ctn').find(".__mst_slider_value").val(ui.value);
		}
	});
};


/**
*	Find all elements that are matching, then run a for loop to differentiate
*	from each of the elements so that they don't conflict with each other during
*	one of the event handlers that are caught
*/
var single_ticks = $('[data-mst-slider="mst-slider-range-single-min-ticks"]');

single_ticks.each(function( o, i ) {

	var elm = $(this);
	
	//Retrieve the input min max values set on the input itself
	var par = elm.parent('.__mst_slider_ctn');
	var inp = par.find('input.__mst_slider_value');

	/**
	*	Add extra width
	*/
	var inpW = inp.outerWidth();
	inp.css('min-width', inpW + 10);

	//Individual options
	var opts = {
		range: 'min',
		step: 10,
		ticks: true
	};

	if(typeof inp.attr('min') != "undefined" && inp.attr('min') != false) {
		opts.min = parseInt(inp.attr('min'));
	}

	if(inp.attr('max') != "undefined" && inp.attr('max') != false) {
		opts.max = parseInt(inp.attr('max'));
	}

	if(inp.attr('step') != "undefined" && inp.attr('step') != false) {
		opts.step = parseInt(inp.attr('step'));
	}

	if(inp.attr('value') != "undefined" && inp.attr('value') != false) {
		opts.value = parseInt(inp.attr('value'));
	}

	//Check to see if there are ticks
	var ticks = par.find('.__mst_slider_tick_ctn');

	if(ticks.length > 0) {
		opts.ticks = true;
	} else {
		opts.ticks = true;
	}

	// console.log(opts);

	customSlider(elm, opts);


});



/**
*	Input control for the slider; 
*	Use the slider's MIN/MAX as bounds
*	Also check to see if the current value is within the allowed steps
*/
$('.__mst_slider_value').on('change', function(ev) {


	var el = $(this);



	var par = el.parents('.__mst_slider_ctn');
	var slider = par.find('.__mst_slider');

	var val = parseInt(el.val());

	el.attr('size', el.val().length);

	if(typeof slider != "undefined") {
		var toTrigger = false;


		$(slider).slider('value', val);


		if(val / $(slider).slider('option', 'step') != 0) {

			toTrigger = true;
			el.val( Math.round(val / $(slider).slider('option', 'step')) * $(slider).slider('option', 'step') );
		}

		if(val > $(slider).slider('option', 'max')) {
			// el.blur();
			el.val('').val($(slider).slider('option', 'max'));
			// console.log($(slider).slider('option', 'max'));
			toTrigger = true;
		} else if(val < $(slider).slider('option', 'min')) {
			// el.blur();
			el.val('').val($(slider).slider('option', 'min'));
			toTrigger = true;
			// console.log($(slider).slider('option', 'min'));
		}

		
		// console.log("triggereeeeeed");
		var step = $(slider).slider('option', 'step');

		if(step >= 1000) {
			var nStep = 1000;
			if(val >= 10000 && val < 20000) {
				nStep = 2000;
			} else if(val >= 20000 && val < 100000) {
				nStep = 5000;
			} else if(val >= 100000 && val < 500000) {
				nStep = 10000;
			} else if(val >= 500000 && val < 800000) {
				nStep = 20000;
			} else if(val >= 800000 && val < 1000000) {
				nStep = 50000;
			} else if(val >= 1000000) {
				nStep = 100000;
			}

			$(slider).slider('option', 'step', nStep);

		}


		if(toTrigger) {

			$(slider).trigger('slideChange');

		}
	}


});


